					//*********************************************************************************
					//
					//     This program is free software; you can redistribute it and/or modify
					//     it under the terms of the GNU General Public License as published by
					//     the Free Software Foundation; either version 2 of the License, or
					//     (at your option) any later version.
					//
					//     This program is distributed in the hope that it will be useful,
					//     but WITHOUT ANY WARRANTY; without even the implied warranty of
					//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
					//     GNU General Public License for more details.
					//
					//    You should have received a copy of the GNU General Public License along
					//    with this program; if not, write to the Free Software Foundation, Inc.,
					//    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
					//    
					//    A copy of the GNU General Public License is also available at
					//    http://www.fsf.org/licensing/licenses
					//
					//*********************************************************************************

					//*********************************************************
					//	Iterate using the LBFGS Method
					//	THE blbfgs vector has been set to zero above
					//*********************************************************
					
					double TOL=LDIFFTOL;

					int HESSIANAPPROX=LBFGSAPPROX;
					
					if(acnt==ANUM){
						TOL=LDIFFTOLPRECOND;
					}
					
					//const unsigned int BITS=PRECBITS;
					unsigned int maxits=MAXITER;
					unsigned int LCNT=0;
					
					
					amp::ampf epsf;
					amp::ampf epsx;
					amp::ampf epsg;

					epsf=TOL;
					epsx=TOL;
					epsg=TOL;
				
					//*************************************************************************
					//	INITIALIZATION OF THE MINIMIZER AND ITS TOLERANCE
					//*************************************************************************
					
					minlbfgs::minlbfgsstate lbfgsstate;
					minlbfgs::minlbfgsreport lbfgsrep;
					ap::template_1d_array< amp::ampf > lbfgsb;
					lbfgsb.setlength(NOMEGA);

					for(int i=0;i<NOMEGA;i++){
				
						mpfr_set(lbfgsb(i).getWritePtr(),blbfgs->data[i],GMP_RNDN);
						
					}
									
					minlbfgs::minlbfgscreate(NOMEGA,HESSIANAPPROX, lbfgsb, lbfgsstate);
					
					minlbfgs::minlbfgssetcond(lbfgsstate, epsg, epsf, epsx, maxits);

					//*************************************************************************
					//	THE ITERATION LOOP                                
					//*************************************************************************

					mpfr_set_ui(Lval,100,GMP_RNDN);
					LTOLCHK=0;
					
					while( minlbfgs::minlbfgsiteration(lbfgsstate) && LTOLCHK<3 && LCNT<MAXITER )
					{
			
						mpfr_set(Lold,Lnew,GMP_RNDN);
						mpfr_set(Sold,Snew,GMP_RNDN);
						mpfr_set(Qold,Qnew,GMP_RNDN);

						for(int i=0;i<NOMEGA;i++){
							
							mpfr_set(a->data[i],lbfgsstate.x(i).getReadPtr(),GMP_RNDN);
							
						}
						
						//*********************************************************
						//	Calculate the current A vector
						//*********************************************************
					
						for(int dw=0;dw<NOMEGA;dw++){
						mpfr_exp(A->data[dw],a->data[dw],GMP_RNDN);
						}
						
						//*********************************************************
						//	ADD THE NECESSARY DW FACTORS FOR THE INTEGRAL
						//*********************************************************
						
						append_dw(Adw,A,omega,NOMEGA,HPNUM,OMEGAHPMIN,OMEGAHPMAX);

						//*********************************************************
						//	Generate data from the current A
						//*********************************************************
					
						gmp_multmv(DCKernel,0,Adw,DA);
					
						//*********************************************************
						//	Calculate L value (3.40)
						//*********************************************************
					
						mpfr_set_ui(Lval,0,GMP_RNDN);
	
						//*********************************************************
						//	IF DATA IS DECORRELATED, ONLY NEED TO USE ONE FOR
						//	LOOP. IF NOT, SLOW DOUBLE LOOP NECCESARY
						//*********************************************************
	
						#if (DECORR==1)
							for(int i=0;i<TWIDTH;i++){
						
								mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
								mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
							
								mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
								mpfr_pow_ui(ptmp1,ptmp3,2,GMP_RNDN);
								
								mpfr_div(ptmp2,ptmp1,CEval->data[i],GMP_RNDN);
								mpfr_div_ui(ptmp3,ptmp2,2,GMP_RNDN);
								
								mpfr_set(ptmp1,Lval,GMP_RNDN);
								mpfr_add(Lval,ptmp1,ptmp3,GMP_RNDN);
								}
						#else
							for(int i=0;i<TWIDTH;i++){
							for(int j=0;j<TWIDTH;j++){
						
								mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
								mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
							
								mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
				
								mpfr_set(ptmp1,DCDXData->data[j],GMP_RNDN);
								mpfr_set(ptmp2,DA->data[j],GMP_RNDN);
				
								mpfr_sub(ptmp4,ptmp1,ptmp2,GMP_RNDN);
				
								mpfr_mul(ptmp1,ptmp3,ptmp4,GMP_RNDN);
				
								gslgmp_matrix_get(CInv,i,j,ptmp2);
				
								mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);
				
								mpfr_div_ui(ptmp2,ptmp3,2,GMP_RNDN);
							
								mpfr_set(ptmp1,Lval,GMP_RNDN);
								mpfr_add(Lval,ptmp1,ptmp2,GMP_RNDN);
								}}
						#endif	
		
						//*********************************************************
						//	FROM NICKEL: THERE NEEDS TO BE A DT TERM
						//	HOWEVER JUST COMES IN AS ALPHA RESCALING
						//*********************************************************

						//*********************************************************
						//	Calculate S value (3.13)
						//*********************************************************
					
						mpfr_set_d(Sval,0.,GMP_RNDN);
		
						for(int dw=0;dw<NOMEGA;dw++){

							mpfr_log(ptmp1, A->data[dw],GMP_RNDN);
							mpfr_log(ptmp2, mprior->data[dw], GMP_RNDN);
							mpfr_sub(ptmp1,ptmp1,ptmp2,GMP_RNDN);
							mpfr_mul(ptmp3,ptmp1,Adw->data[dw],GMP_RNDN);
							
							mpfr_sub(ptmp1,Adw->data[dw],mpriordw->data[dw],GMP_RNDN);
							mpfr_sub(ptmp2,ptmp1,ptmp3,GMP_RNDN);

							mpfr_set(ptmp1,Sval,GMP_RNDN);
							mpfr_add(Sval,ptmp1,ptmp2,GMP_RNDN);
		
						}
		
						//*********************************************************
						//	IF FULLQ==1 THEN Q IS MINIMIZED
						//	IF FULLQ==0 THEN only L IS MINIMIZED
						//*********************************************************
						
						if (FULLQ==0){
							mpfr_set(lbfgsstate.f.getWritePtr(),Lval,GMP_RNDN);
						}else if (FULLQ==2){
							mpfr_neg(lbfgsstate.f.getWritePtr(),Sval,GMP_RNDN);
						}else if (FULLQ==1){
							mpfr_set_d(ptmp1,alpha,GMP_RNDN);
							mpfr_mul(ptmp2,ptmp1,Sval,GMP_RNDN);
							mpfr_sub(lbfgsstate.f.getWritePtr(),Lval,ptmp2,GMP_RNDN);
							mpfr_set(Qnew,lbfgsstate.f.getReadPtr(),GMP_RNDN);
						}else{
							fprintf(stderr, "THERE ARE ONLY THREE CHOICES TO MINIMIZE, 0=L 1=Q 2=S\n"); exit(-1);
						}
		
						mpfr_set(Lnew,Lval,GMP_RNDN);
						mpfr_set(Snew,Sval,GMP_RNDN);
					
						for(int comp=0;comp<NOMEGA;comp++){
					
							//*********************************************************
							//	Calculate the derivative of L w.r.t. a_k
							//*********************************************************
		
							mpfr_set_ui(Lderiv,0,GMP_RNDN);
						
							#if (DECORR==1)
							
							for(int i=0;i<TWIDTH;i++){
					
								mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
								mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
								mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
							
								gslgmp_matrix_get(DCKernel,i,comp,ptmp1);
								
								mpfr_mul(ptmp2,ptmp1,Adw->data[comp],GMP_RNDN); //FROM COMPARISON OF THE NUMERICAL DERIVATIVE
								
								mpfr_mul(ptmp1,ptmp2,ptmp3,GMP_RNDN);
				
								mpfr_div(ptmp2,ptmp1,CEval->data[i],GMP_RNDN);
				
								mpfr_set(ptmp3,Lderiv,GMP_RNDN);
								mpfr_sub(Lderiv,ptmp3,ptmp2,GMP_RNDN);
								}
								
							#else

							for(int i=0;i<TWIDTH;i++){
							for(int j=0;j<TWIDTH;j++){
					
								mpfr_set(ptmp1,DCDXData->data[j],GMP_RNDN);
								mpfr_set(ptmp2,DA->data[j],GMP_RNDN);
								mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
							
								gslgmp_matrix_get(DCKernel,i,comp,ptmp1);
								
								mpfr_mul(ptmp2,ptmp1,Adw->data[comp],GMP_RNDN);//FROM COMPARISON OF THE NUMERICAL DERIVATIVE
								
								mpfr_mul(ptmp1,ptmp2,ptmp3,GMP_RNDN);
			
								gslgmp_matrix_get(CInv,i,j,ptmp2);
								mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);
				
								mpfr_set(ptmp2,Lderiv,GMP_RNDN);
								mpfr_sub(Lderiv,ptmp2,ptmp3,GMP_RNDN);
							}}
		
							#endif
							//*********************************************************
							//	FROM NICKEL: THERE NEEDS TO BE A DT TERM
							//	HOWEVER JUST COMES IN AS ALPHA RESCALING
							//*********************************************************

							//*********************************************************
							//	Calculate the derivative of S
							//*********************************************************
		
							mpfr_set_ui(Sderiv,0,GMP_RNDN);

							mpfr_div(ptmp1,A->data[comp],mprior->data[comp],GMP_RNDN);
							mpfr_log(ptmp2,ptmp1,GMP_RNDN);

							mpfr_mul(ptmp3,ptmp2,Adw->data[comp],GMP_RNDN);//FROM COMPARISON OF THE NUMERICAL DERIVATIVE
							
							mpfr_set(ptmp1,Sderiv,GMP_RNDN);
							mpfr_sub(Sderiv,ptmp1,ptmp3,GMP_RNDN);
														
							if (FULLQ==0){
								mpfr_set(lbfgsstate.g(comp).getWritePtr(),Lderiv,GMP_RNDN);
							} else if (FULLQ==2){
								mpfr_neg(lbfgsstate.g(comp).getWritePtr(),Sderiv,GMP_RNDN);
							} else if (FULLQ==1){
								mpfr_set_d(ptmp1,alpha,GMP_RNDN);
								mpfr_mul(ptmp2,ptmp1,Sderiv,GMP_RNDN);
								mpfr_sub(lbfgsstate.g(comp).getWritePtr(),Lderiv,ptmp2,GMP_RNDN);
							}
							
						}
		
						//*********************************************************
						//	Measure |dL|
						//*********************************************************
						
						mpfr_set_ui(ptmp4,0,GMP_RNDN);
						
						for(int i=0; i<NOMEGA; i++){
							mpfr_pow_ui(ptmp1,lbfgsstate.g(i).getReadPtr(),2,GMP_RNDN);
							mpfr_add(ptmp4,ptmp4, ptmp1,GMP_RNDN);
						
						}
						
						//*********************************************************
						//	Print status report for the current iteration
						//*********************************************************

						if (FULLQ==0){
						fprintf(stderr, "Iter %3d with ALPHA:%e L:% 1.3e dL^2:%1.3e ", iter,alpha,mpfr_get_d(Lval,GMP_RNDN), mpfr_get_d(ptmp4,GMP_RNDN));
						}else if (FULLQ==2){
						fprintf(stderr, "Iter %3d with ALPHA:%e S:% 1.3e dS^2:%1.3e ", iter,alpha,mpfr_get_d(Sval,GMP_RNDN), mpfr_get_d(ptmp4,GMP_RNDN));							
						}else if (FULLQ==1){
						fprintf(stderr, "Iter %3d with ALPHA:%e Q:%1.3e dQ^2:%1.3e L:% 1.3e S:% 1.3e ", iter,alpha, -mpfr_get_d(Lval,GMP_RNDN)+alpha*mpfr_get_d(Sval,GMP_RNDN),mpfr_get_d(ptmp4,GMP_RNDN),mpfr_get_d(Lval,GMP_RNDN),mpfr_get_d(Sval,GMP_RNDN) );
						}


						//*********************************************************
						//	Additional Convergence check
						//*********************************************************
		
						if (FULLQ==0){
						if(mpfr_cmp (Lold,Lnew) > 0) {mpfr_set(ptmp3,Lnew,GMP_RNDN);}else{mpfr_set(ptmp3,Lold,GMP_RNDN);}
				
						mpfr_sub(ptmp1,Lold,Lnew,GMP_RNDN);
						mpfr_div(ptmp2,ptmp1,ptmp3,GMP_RNDN);
						mpfr_abs(ptmp2,ptmp2,GMP_RNDN);
						mpfr_set_d(ptmp1,TOL,GMP_RNDN);
		
						if((mpfr_less_p(ptmp2,ptmp1)!=0)) {LTOLCHK++;}else{ LTOLCHK=0; }
		
						if((mpfr_less_p(Lnew,ptmp1)!=0)) {LTOLCHK=2;}
		
						fprintf(stderr, "Lold:%1.3e Lnew:%1.3e |Lold-Lnew|/Min(Lnew,Lold):%1.3e QDIFFTOL:%1.3e QTOLCHK:%d\r", mpfr_get_d(Lold,GMP_RNDN),mpfr_get_d(Lnew,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN),TOL,LTOLCHK);
		
						} else if (FULLQ==2){
							
						if(mpfr_cmp (Sold,Snew) > 0) {mpfr_set(ptmp3,Snew,GMP_RNDN);}else{mpfr_set(ptmp3,Sold,GMP_RNDN);}
				
						mpfr_sub(ptmp1,Sold,Snew,GMP_RNDN);
						mpfr_div(ptmp2,ptmp1,ptmp3,GMP_RNDN);
						mpfr_abs(ptmp2,ptmp2,GMP_RNDN);
						mpfr_set_d(ptmp1,TOL,GMP_RNDN);
		
						if((mpfr_less_p(ptmp2,ptmp1)!=0)) {LTOLCHK++;}else{ LTOLCHK=0; }
		
						if((mpfr_less_p(Lnew,ptmp1)!=0)) {LTOLCHK=2;}
		
						fprintf(stderr, "Sold:%1.3e Snew:%1.3e |Sold-Snew|/Min(Snew,Sold):%1.3e QDIFFTOL:%1.3e QTOLCHK:%d\r", mpfr_get_d(Sold,GMP_RNDN),mpfr_get_d(Snew,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN),TOL,LTOLCHK);
		
						}else if (FULLQ==1){
							
						if(mpfr_cmp (Qold,Qnew) > 0) {mpfr_set(ptmp3,Qnew,GMP_RNDN);}else{mpfr_set(ptmp3,Qold,GMP_RNDN);}
				
						mpfr_sub(ptmp1,Qold,Qnew,GMP_RNDN);
						mpfr_div(ptmp2,ptmp1,ptmp3,GMP_RNDN);
						mpfr_abs(ptmp2,ptmp2,GMP_RNDN);
						mpfr_set_d(ptmp1,TOL,GMP_RNDN);
		
						if((mpfr_less_p(ptmp2,ptmp1)!=0)) {LTOLCHK++;}else{ LTOLCHK=0; }
		
						fprintf(stderr, "Qold:%1.3e Qnew:%1.3e |Qold-Qnew|/Min(Qnew,Qold):%1.3e QDIFFTOL:%1.3e QTOLCHK:%d\r", mpfr_get_d(Qold,GMP_RNDN),mpfr_get_d(Qnew,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN),TOL,LTOLCHK);
						}
						
						//*********************************************************
						//	CHECK FOR NAN OR INFS
						//*********************************************************
						
						while ( mpfr_nan_p (Snew) || mpfr_nan_p (Lnew) || mpfr_nan_p (Qnew) ){
							
							fprintf(stderr, "ENCOUNTERED NAN IN EITHER L OR S. PERTURBING THE A VECTOR:\n");
							
							for(int w=0;w<NOMEGA;w++){
							
								mpfr_div_d(lbfgsstate.x(w).getWritePtr(),lbfgsstate.x(w).getReadPtr(),1.2,GMP_RNDN);
								mpfr_mul_d(ptmp1, lbfgsstate.x(w).getReadPtr(), (0.05*( 2.*((double)(rand()%100))/100.-1.)) , GMP_RNDN);
								mpfr_add(lbfgsstate.x(w).getWritePtr(), lbfgsstate.x(w).getWritePtr(), ptmp1,GMP_RNDN);
							
							}
							
							
							for(int i=0;i<NOMEGA;i++){
								
								mpfr_set(a->data[i],lbfgsstate.x(i).getReadPtr(),GMP_RNDN);
							
							}
							
							//*********************************************************
							//	Calculate the current A vector
							//*********************************************************
						
							for(int dw=0;dw<NOMEGA;dw++){
							mpfr_exp(A->data[dw],a->data[dw],GMP_RNDN);
							}
							
							//*********************************************************
							//	ADD THE NECESSARY DW FACTORS FOR THE INTEGRAL
							//*********************************************************
							
							append_dw(Adw,A,omega,NOMEGA,HPNUM,OMEGAHPMIN,OMEGAHPMAX);

							//*********************************************************
							//	Generate data from the current A
							//*********************************************************
						
							gmp_multmv(DCKernel,0,Adw,DA);
						
							//*********************************************************
							//	Calculate L value (3.40)
							//*********************************************************
						
							mpfr_set_ui(Lval,0,GMP_RNDN);
		
							//*********************************************************
							//	IF DATA IS DECORRELATED, ONLY NEED TO USE ONE FOR
							//	LOOP. IF NOT, SLOW DOUBLE LOOP NECCESARY
							//*********************************************************
		
							#if (DECORR==1)
								for(int i=0;i<TWIDTH;i++){
							
									mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
									mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
								
									mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
									mpfr_pow_ui(ptmp1,ptmp3,2,GMP_RNDN);
									
									mpfr_div(ptmp2,ptmp1,CEval->data[i],GMP_RNDN);
									mpfr_div_ui(ptmp3,ptmp2,2,GMP_RNDN);
									
									mpfr_set(ptmp1,Lval,GMP_RNDN);
									mpfr_add(Lval,ptmp1,ptmp3,GMP_RNDN);
									}
							#else
								for(int i=0;i<TWIDTH;i++){
								for(int j=0;j<TWIDTH;j++){
							
									mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
									mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
								
									mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
					
									mpfr_set(ptmp1,DCDXData->data[j],GMP_RNDN);
									mpfr_set(ptmp2,DA->data[j],GMP_RNDN);
					
									mpfr_sub(ptmp4,ptmp1,ptmp2,GMP_RNDN);
					
									mpfr_mul(ptmp1,ptmp3,ptmp4,GMP_RNDN);
					
									gslgmp_matrix_get(CInv,i,j,ptmp2);
					
									mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);
					
									mpfr_div_ui(ptmp2,ptmp3,2,GMP_RNDN);
								
									mpfr_set(ptmp1,Lval,GMP_RNDN);
									mpfr_add(Lval,ptmp1,ptmp2,GMP_RNDN);
									}}
							#endif	
			
							//*********************************************************
							//	FROM NICKEL: THERE NEEDS TO BE A DT TERM
							//	HOWEVER JUST COMES IN AS ALPHA RESCALING
							//*********************************************************

							//*********************************************************
							//	Calculate S value (3.13)
							//*********************************************************
						
							mpfr_set_d(Sval,0.,GMP_RNDN);
			
							for(int dw=0;dw<NOMEGA;dw++){

								mpfr_log(ptmp1, A->data[dw],GMP_RNDN);
								mpfr_log(ptmp2, mprior->data[dw], GMP_RNDN);
								mpfr_sub(ptmp1,ptmp1,ptmp2,GMP_RNDN);
								mpfr_mul(ptmp3,ptmp1,Adw->data[dw],GMP_RNDN);
								
								mpfr_sub(ptmp1,Adw->data[dw],mpriordw->data[dw],GMP_RNDN);
								mpfr_sub(ptmp2,ptmp1,ptmp3,GMP_RNDN);

								mpfr_set(ptmp1,Sval,GMP_RNDN);
								mpfr_add(Sval,ptmp1,ptmp2,GMP_RNDN);
			
							}
						
							//*********************************************************
							//	IF FULLQ==1 THEN Q IS MINIMIZED
							//	IF FULLQ==0 THEN only L IS MINIMIZED
							//*********************************************************

							if (FULLQ==0){
								mpfr_set(lbfgsstate.f.getWritePtr(),Lval,GMP_RNDN);
							}else if (FULLQ==2) {
								mpfr_neg(lbfgsstate.f.getWritePtr(),Sval,GMP_RNDN);
							} else if (FULLQ==1){
								mpfr_set_d(ptmp1,alpha,GMP_RNDN);
								mpfr_mul(ptmp2,ptmp1,Sval,GMP_RNDN);
								mpfr_sub(lbfgsstate.f.getWritePtr(),Lval,ptmp2,GMP_RNDN);
								mpfr_set(Qnew,lbfgsstate.f.getReadPtr(),GMP_RNDN);
							}
			
							mpfr_set(Lnew,Lval,GMP_RNDN);
							mpfr_set(Snew,Sval,GMP_RNDN);
						
							for(int comp=0;comp<NOMEGA;comp++){
						
								//*********************************************************
								//	Calculate the derivative of L w.r.t. a_k
								//*********************************************************
			
								mpfr_set_ui(Lderiv,0,GMP_RNDN);
							
								#if (DECORR==1)
								
								for(int i=0;i<TWIDTH;i++){
						
									mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
									mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
									mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
								
									gslgmp_matrix_get(DCKernel,i,comp,ptmp1);

									#if (WITHDW==0)
									mpfr_mul(ptmp2,ptmp1,A->data[comp],GMP_RNDN); //DELTA FUNCTION INTRODUCES 1/dw
									#else
									mpfr_mul(ptmp2,ptmp1,Adw->data[comp],GMP_RNDN); //FROM COMPARISON OF THE NUMERICAL DERIVATIVE
									#endif
									
									mpfr_mul(ptmp1,ptmp2,ptmp3,GMP_RNDN);
					
									mpfr_div(ptmp2,ptmp1,CEval->data[i],GMP_RNDN);
					
									mpfr_set(ptmp3,Lderiv,GMP_RNDN);
									mpfr_sub(Lderiv,ptmp3,ptmp2,GMP_RNDN);
									}
									
								#else

								for(int i=0;i<TWIDTH;i++){
								for(int j=0;j<TWIDTH;j++){
						
									mpfr_set(ptmp1,DCDXData->data[j],GMP_RNDN);
									mpfr_set(ptmp2,DA->data[j],GMP_RNDN);
									mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
								
									gslgmp_matrix_get(DCKernel,i,comp,ptmp1);
									
									#if (WITHDW==0)
									mpfr_mul(ptmp2,ptmp1,A->data[comp],GMP_RNDN);//DELTA FUNCTION INTRODUCES 1/dw
									#else
									mpfr_mul(ptmp2,ptmp1,Adw->data[comp],GMP_RNDN);//FROM COMPARISON OF THE NUMERICAL DERIVATIVE
									#endif
									
									mpfr_mul(ptmp1,ptmp2,ptmp3,GMP_RNDN);
				
									gslgmp_matrix_get(CInv,i,j,ptmp2);
									mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);
					
									mpfr_set(ptmp2,Lderiv,GMP_RNDN);
									mpfr_sub(Lderiv,ptmp2,ptmp3,GMP_RNDN);
								}}
			
								#endif
								//*********************************************************
								//	FROM NICKEL: THERE NEEDS TO BE A DT TERM
								//	HOWEVER JUST COMES IN AS ALPHA RESCALING
								//*********************************************************

								//*********************************************************
								//	Calculate the derivative of S
								//*********************************************************
			
								mpfr_set_ui(Sderiv,0,GMP_RNDN);

								mpfr_div(ptmp1,A->data[comp],mprior->data[comp],GMP_RNDN);
								mpfr_log(ptmp2,ptmp1,GMP_RNDN);

								#if (WITHDW==0)
								mpfr_mul(ptmp3,ptmp2,A->data[comp],GMP_RNDN); //DELTA FUNCTION INTRODUCES 1/dw
								#else
								mpfr_mul(ptmp3,ptmp2,Adw->data[comp],GMP_RNDN);//FROM COMPARISON OF THE NUMERICAL DERIVATIVE
								#endif
								
								mpfr_set(ptmp1,Sderiv,GMP_RNDN);
								mpfr_sub(Sderiv,ptmp1,ptmp3,GMP_RNDN);
								
								
								if (FULLQ==0){
								mpfr_set(lbfgsstate.g(comp).getWritePtr(),Lderiv,GMP_RNDN);
								} else if (FULLQ==2){
								mpfr_neg(lbfgsstate.g(comp).getWritePtr(),Sderiv,GMP_RNDN);
								}else if (FULLQ==1){
								mpfr_set_d(ptmp1,alpha,GMP_RNDN);
								mpfr_mul(ptmp2,ptmp1,Sderiv,GMP_RNDN);
								mpfr_sub(lbfgsstate.g(comp).getWritePtr(),Lderiv,ptmp2,GMP_RNDN);
								}
								
							}							
							
						}
						
						//*********************************************************
						//	CEHCK THE DEVIATION FROM SINGULAR SUBSPACE      
						//*********************************************************
						
						if(CHECKSINGSUB!=0) if(iter%CHECKSINGSUB==0){
							
							//*********************************************************
							//	NOW PROJECT DOWN TO THE SINGULAR SUBSPACE USING
							//	THE ORTHONORMALITY OF THE MATRIX Us
							//*********************************************************
							fprintf(stderr, "\n**********************************************************\n");
							fprintf(stderr, "***   PROJECT ONTO THE SINGULAR SUBSPACE, SHOULD GIVE    ***\n");
							fprintf(stderr, "***   ONLY SMALL DEVIATION BETWEEN THE A's AS WE EXPECT  ***\n");
							fprintf(stderr, "***   THAT THE MINIMUM lIES WITHIN THE SINGULAR SUBSPACE ***\n");
							fprintf(stderr, "**********************************************************\n");

							blbfgsSVD=gslgmp_vector_calloc(NSING);
							
							for(int COMP=0;COMP<NSING;COMP++){
								
								//*********************************************************
								//	WE NEED THE VECTOR PRODUCT BETWEEN THE COLUMNS OF
								//	US AND THE CURRENT a AS WELL AS THEIR NORM (=1)
								//*********************************************************
								
								mpfr_set_ui(ptmp1,0,GMP_RNDN);
								
								for(int w=0;w<NOMEGA;w++){
								
									mpfr_mul(ptmp4,lbfgsstate.x(w).getReadPtr(),Us->data[w*NSING+COMP],GMP_RNDN);
									mpfr_add(ptmp1,ptmp1,ptmp4,GMP_RNDN);

								}
								
								mpfr_set(blbfgsSVD->data[COMP],ptmp1,GMP_RNDN);
								
								fprintf(stderr, "SUBSPACE b[%d]:%e\n", COMP, mpfr_get_d(blbfgsSVD->data[COMP],GMP_RNDN));
								
							}
							
							gmp_multmv(Us,0,blbfgsSVD,a);
							
							mpfr_set_ui(ptmp4,0,GMP_RNDN);
							
							for(int i=0;i<NOMEGA;i++){
								
								mpfr_sub(ptmp1,a->data[i],lbfgsstate.x(i).getReadPtr(),GMP_RNDN);
								mpfr_pow_ui(ptmp1,ptmp1,2,GMP_RNDN);
								mpfr_mul_d(ptmp1,ptmp1,0.5,GMP_RNDN);
							
								mpfr_add(ptmp4,ptmp4,ptmp1,GMP_RNDN);
							}
							
							mpfr_sqrt(ptmp4,ptmp4,GMP_RNDN);
							mpfr_div_ui(ptmp4,ptmp4,NOMEGA,GMP_RNDN);
							
							fprintf(stderr, "Difference in a after projection: %e\n", mpfr_get_d(ptmp4,GMP_RNDN));
								
							gslgmp_vector_free(blbfgsSVD);	
							
							fprintf(PROJVAL, "%d %d %d %e\n", DX, acnt, iter,mpfr_get_d(ptmp4,GMP_RNDN));
							fflush(PROJVAL);
							
						}
						
						fprintf(ITERVAL, "%d %d %d %e %e %e\n", DX, acnt, iter, mpfr_get_d(Lval,GMP_RNDN),mpfr_get_d(Sval,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN));
						fflush(ITERVAL);
						iter++;
						
						if( (LCNT==MAXITER-1) && (mpfr_get_d(ptmp2,GMP_RNDN) > 1e-3) ) LCNT--;
						LCNT++;
					}

					if(LTOLCHK!=3){
						
						if(LCNT!=MAXITER){
							minlbfgs::minlbfgsresults(lbfgsstate, lbfgsb, lbfgsrep);					
							fprintf(stderr,"\n\nLBFGS INTERNAL TERMINATION TYPE:%d\n",lbfgsrep.terminationtype);
							
							for(int dw=0;dw<NOMEGA;dw++){
							mpfr_set(blbfgs->data[dw],lbfgsb(dw).getReadPtr(),GMP_RNDN);
							}
						}else{
							fprintf(stderr,"\n\nLBFGS FINISHED BECAUSE MAXITER REACHED %d %d\n",LCNT,MAXITER);
				
							for(int dw=0;dw<NOMEGA;dw++){
							mpfr_set(blbfgs->data[dw],lbfgsstate.x(dw).getReadPtr(),GMP_RNDN);
							}
						
						}
		
					}else{
						fprintf(stderr,"\n\nLBFGS FINISHED BECAUSE (qold-qnew)/qnew < TOL\n");
			
						for(int dw=0;dw<NOMEGA;dw++){
						mpfr_set(blbfgs->data[dw],lbfgsstate.x(dw).getReadPtr(),GMP_RNDN);
						}
					}
		
