					//*********************************************************************************
					//
					//     This program is free software; you can redistribute it and/or modify
					//     it under the terms of the GNU General Public License as published by
					//     the Free Software Foundation; either version 2 of the License, or
					//     (at your option) any later version.
					//
					//     This program is distributed in the hope that it will be useful,
					//     but WITHOUT ANY WARRANTY; without even the implied warranty of
					//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
					//     GNU General Public License for more details.
					//
					//    You should have received a copy of the GNU General Public License along
					//    with this program; if not, write to the Free Software Foundation, Inc.,
					//    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
					//    
					//    A copy of the GNU General Public License is also available at
					//    http://www.fsf.org/licensing/licenses
					//
					//*********************************************************************************

					//*************************************************************************
					//	PREPARATION OF THE LBFGS + LM MINIMIZER        
					//*************************************************************************
					
					mpfr_t Lderiva,Lderivb;
					mpfr_init2(Lderiva,PRECBITS);
					mpfr_init2(Lderivb,PRECBITS);
					
					double TOL=LDIFFTOL;
					
					if(acnt==ANUM){
						TOL=LDIFFTOLPRECOND;
					}
					
					//const unsigned int BITS=PRECBITS;
					
					amp::ampf epsf;
					amp::ampf epsx;
					amp::ampf epsg;
					
					int maxits=MAXITER;

					epsf=TOL;
					epsx=TOL;
					epsg=TOL;
				
					//*************************************************************************
					//	INITIALIZATION OF THE LBFGS MINIMIZER AND ITS TOLERANCE
					//*************************************************************************
					
					minlbfgs::minlbfgsstate lbfgsstate;
					minlbfgs::minlbfgsreport lbfgsrep;
					ap::template_1d_array< amp::ampf > lbfgsb;
					
					if(acnt==ANUM){
					
					lbfgsb.setlength(NSINGEXT);

					for(int i=0;i<NSINGEXT;i++){
				
						mpfr_set(lbfgsb(i).getWritePtr(),blbfgsSVD->data[i],GMP_RNDN);
						
					}
					
 					
					minlbfgs::minlbfgscreate(NSINGEXT, NSINGEXT<6?6:NSINGEXT , lbfgsb, lbfgsstate);
					
					minlbfgs::minlbfgssetcond(lbfgsstate, epsg, epsf, epsx, maxits);

					//*************************************************************************
					//	THE ITERATION LOOP                                
					//*************************************************************************
			
					fprintf(stderr, "\n**********************************************************\n");
					fprintf(stderr, "**** STARTING WITH THE LBFGS PRECONDITIONER       ********\n");
					fprintf(stderr, "**********************************************************\n");

					while( minlbfgs::minlbfgsiteration(lbfgsstate) && mpfr_get_d(Qnew,GMP_RNDN)>1e12 )
					{
				
						mpfr_set(Lold,Lnew,GMP_RNDN);
						mpfr_set(Sold,Snew,GMP_RNDN);
						mpfr_set(Qold,Qnew,GMP_RNDN);
						
						for(int i=0;i<NSINGEXT;i++){
						mpfr_set(b->data[i],lbfgsstate.x(i).getReadPtr(),GMP_RNDN);						
						}
			
						//*********************************************************
						//	Calculate the current A vector
						//*********************************************************

						gmp_multmv(UsExt,0,b,a);

						for(int dw=0;dw<NOMEGA;dw++){
						mpfr_exp(A->data[dw],a->data[dw],GMP_RNDN);						
						mpfr_mul(A->data[dw],A->data[dw],mprior->data[dw],GMP_RNDN);
						}
						
						//*********************************************************
						//	ADD THE NECESSARY DW FACTORS FOR THE INTEGRAL
						//*********************************************************
						
						append_dw(Adw,A,omega,NOMEGA,HPNUM,OMEGAHPMIN,OMEGAHPMAX);

						//*********************************************************
						//	Generate data from the current A
						//*********************************************************
					
						gmp_multmv(DCKernel,0,Adw,DA);
					
						//*********************************************************
						//	Calculate L value (3.40)
						//*********************************************************
				
						mpfr_set_ui(Lval,0,GMP_RNDN);
	
						//*********************************************************
						//	IF DATA IS DECORRELATED, ONLY NEED TO USE ONE FOR
						//	LOOP. IF NOT, SLOW DOUBLE LOOP NECCESARY
						//*********************************************************
	
						#if (DECORR==1)
							for(int i=0;i<TWIDTH;i++){
						
								mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
								mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
							
								mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
								mpfr_pow_ui(ptmp1,ptmp3,2,GMP_RNDN);
								
								mpfr_div(ptmp2,ptmp1,CEval->data[i],GMP_RNDN);
								mpfr_div_ui(ptmp3,ptmp2,2,GMP_RNDN);
								
								mpfr_set(ptmp1,Lval,GMP_RNDN);
								mpfr_add(Lval,ptmp1,ptmp3,GMP_RNDN);
								}
						#else
							for(int i=0;i<TWIDTH;i++){
							for(int j=0;j<TWIDTH;j++){
						
								mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
								mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
							
								mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
				
								mpfr_set(ptmp1,DCDXData->data[j],GMP_RNDN);
								mpfr_set(ptmp2,DA->data[j],GMP_RNDN);
				
								mpfr_sub(ptmp4,ptmp1,ptmp2,GMP_RNDN);
				
								mpfr_mul(ptmp1,ptmp3,ptmp4,GMP_RNDN);
				
								gslgmp_matrix_get(CInv,i,j,ptmp2);
				
								mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);
				
								mpfr_div_ui(ptmp2,ptmp3,2,GMP_RNDN);
							
								mpfr_set(ptmp1,Lval,GMP_RNDN);
								mpfr_add(Lval,ptmp1,ptmp2,GMP_RNDN);
								}}
						#endif	
		
// 						fprintf(stderr, "LVALUE: %e\n",mpfr_get_d(Lval,GMP_RNDN));
		
						//*********************************************************
						//	FROM NICKEL: THERE NEEDS TO BE A DT TERM
						//	HOWEVER JUST COMES IN AS ALPHA RESCALING
						//*********************************************************

						//*********************************************************
						//	Calculate S value (3.13)
						//*********************************************************
					
						mpfr_set_d(Sval,0.,GMP_RNDN);
		
						for(int dw=0;dw<NOMEGA;dw++){

							mpfr_div(ptmp1, A->data[dw],mprior->data[dw],GMP_RNDN);
							mpfr_log(ptmp2,ptmp1,GMP_RNDN);
							mpfr_mul(ptmp3,ptmp2,Adw->data[dw],GMP_RNDN);
							
							mpfr_sub(ptmp1,Adw->data[dw],mpriordw->data[dw],GMP_RNDN);
							mpfr_sub(ptmp2,ptmp1,ptmp3,GMP_RNDN);

							mpfr_set(ptmp1,Sval,GMP_RNDN);
							mpfr_add(Sval,ptmp1,ptmp2,GMP_RNDN);
		
						}
// 						fprintf(stderr, "SVALUE: %e\n",mpfr_get_d(Sval,GMP_RNDN));
		
						//*********************************************************
						//	IF FULLQ==1 THEN Q IS MINIMIZED
						//	IF FULLQ==0 THEN only L IS MINIMIZED
						//*********************************************************
						
						if (FULLQ==0){
							mpfr_set(lbfgsstate.f.getWritePtr(),Lval,GMP_RNDN);
						}else if (FULLQ==2){
							mpfr_neg(lbfgsstate.f.getWritePtr(),Sval,GMP_RNDN);
						}else if (FULLQ==1){
							mpfr_set_d(ptmp1,alpha,GMP_RNDN);
							mpfr_mul(ptmp2,ptmp1,Sval,GMP_RNDN);
							mpfr_sub(lbfgsstate.f.getWritePtr(),Lval,ptmp2,GMP_RNDN);
							mpfr_set(Qnew,lbfgsstate.f.getReadPtr(),GMP_RNDN);
						}else{
							fprintf(stderr, "THERE ARE ONLY THREE CHOICES TO MINIMIZE, 0=L 1=Q 2=S\n"); exit(-1);
						}
		
// 						fprintf(stderr, "QVALUE: %e\n",mpfr_get_d(Qnew,GMP_RNDN));

		
						//*********************************************************
						//	CALCULATE THE TRUE -Q DERIVATIVE             
						//*********************************************************
						
							mpfr_set(Lnew,Lval,GMP_RNDN);
							mpfr_set(Snew,Sval,GMP_RNDN);
						
							for(int comp=0;comp<NSINGEXT;comp++){
								
								//*********************************************************
								//	Calculate the derivative of L w.r.t. a_k
								//*********************************************************
			
								mpfr_set_ui(Lderiv,0,GMP_RNDN);
							
								#if (DECORR==1)
								
								for(int i=0;i<TWIDTH;i++){
						
									mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
									mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
									mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);

									mpfr_set_ui(ptmp4,0,GMP_RNDN);
									
									for(int l=0; l<NOMEGA;l++){
									
									#if (WITHDW==0)
										mpfr_mul(ptmp1,DCKernel->data[i*(NOMEGA)+l],A->data[l],GMP_RNDN);
									#else
										mpfr_mul(ptmp1,DCKernel->data[i*(NOMEGA)+l],Adw->data[l],GMP_RNDN);
									#endif
									
										mpfr_mul(ptmp1,ptmp1,UsExt->data[l*(NSINGEXT)+comp],GMP_RNDN);
										mpfr_add(ptmp4,ptmp4,ptmp1,GMP_RNDN);
																			
									}
									
									mpfr_mul(ptmp1,ptmp3,ptmp4,GMP_RNDN);
									mpfr_div(ptmp2,ptmp1,CEval->data[i],GMP_RNDN);
					
									mpfr_sub(Lderiv,Lderiv,ptmp2,GMP_RNDN);
									}
									
								#else

									fprintf(stderr, "NOT IMPLEMENTED YET\n"); exit(-1);

								#endif
								//*********************************************************
								//	FROM NICKEL: THERE NEEDS TO BE A DT TERM
								//	HOWEVER JUST COMES IN AS ALPHA RESCALING
								//*********************************************************

								//*********************************************************
								//	Calculate the derivative of S
								//*********************************************************
			
								mpfr_set_ui(Sderiv,0,GMP_RNDN);

								
								for(int l=0; l<NOMEGA;l++){
								
									mpfr_div(ptmp1,A->data[comp],mprior->data[comp],GMP_RNDN);
									mpfr_log(ptmp2,ptmp1,GMP_RNDN);

									#if (WITHDW==0)
									mpfr_mul(ptmp1,UsExt->data[l*(NSINGEXT)+comp],A->data[comp],GMP_RNDN); //DELTA FUNCTION INTRODUCES 1/dw
									#else
									mpfr_mul(ptmp1,UsExt->data[l*(NSINGEXT)+comp],Adw->data[comp],GMP_RNDN);//FROM COMPARISON OF THE NUMERICAL DERIVATIVE
									#endif
									
									mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);
									
									mpfr_sub(Sderiv,Sderiv,ptmp3,GMP_RNDN);
								
								}
								
								if (FULLQ==0){
									mpfr_set(lbfgsstate.g(comp).getWritePtr(),Lderiv,GMP_RNDN);
								}else if (FULLQ==2) {
									mpfr_neg(lbfgsstate.g(comp).getWritePtr(),Sderiv,GMP_RNDN);
								}else if (FULLQ==1){
									mpfr_set_d(ptmp1,alpha,GMP_RNDN);
									mpfr_mul(ptmp2,ptmp1,Sderiv,GMP_RNDN);
									mpfr_sub(lbfgsstate.g(comp).getWritePtr(),Lderiv,ptmp2,GMP_RNDN);
								}
								
							}
					
						
		
						//*********************************************************
						//	Measure |dL|
						//*********************************************************
						
						double dQ=0;
						for(int i=0; i<NSINGEXT;i++) dQ+=mpfr_get_d(lbfgsstate.g(i).getReadPtr(),GMP_RNDN);
						
						fprintf(stderr, "dQVALUE: %e\n",dQ);

						//*********************************************************
						//	Print status report for the current iteration
						//*********************************************************

						if (FULLQ==0) {
						fprintf(stderr, "N%3d Iter %3d with ALPHA:%e L:% 1.3e dL:%1.3e ", MYRANK, iter,alpha,mpfr_get_d(Lval,GMP_RNDN), dQ);
						} else if (FULLQ==2){
						fprintf(stderr, "N%3d Iter %3d with ALPHA:%e S:% 1.3e dS:%1.3e ", MYRANK, iter,alpha,mpfr_get_d(Sval,GMP_RNDN), dQ);
						} else if (FULLQ==1){
						fprintf(stderr, "N%3d Iter %3d with ALPHA:%e Q:% 1.3e dQ:%1.3e L:% 1.3e S:% 1.3e ", MYRANK, iter,alpha,mpfr_get_d(lbfgsstate.f.getReadPtr(),GMP_RNDN),dQ,mpfr_get_d(Lval,GMP_RNDN),mpfr_get_d(Sval,GMP_RNDN) );
						}


						//*********************************************************
						//	Additional Convergence check
						//*********************************************************
		
						if (FULLQ==0){
							
							if(mpfr_cmp (Lold,Lnew) > 0) {mpfr_set(ptmp3,Lnew,GMP_RNDN);}else{mpfr_set(ptmp3,Lold,GMP_RNDN);}
					
							mpfr_sub(ptmp1,Lold,Lnew,GMP_RNDN);
							mpfr_div(ptmp2,ptmp1,ptmp3,GMP_RNDN);
							mpfr_abs(ptmp2,ptmp2,GMP_RNDN);
							mpfr_set_d(ptmp1,TOL,GMP_RNDN);
			
							if((mpfr_less_p(ptmp2,ptmp1)!=0)) {LTOLCHK++;}else{ LTOLCHK=0; }
			
							if((mpfr_less_p(Lnew,ptmp1)!=0)) {LTOLCHK=2;}
			
							fprintf(stderr, "Lold:%1.3e Lnew:%1.3e |Lold-Lnew|/Min(Lnew,Lold):%1.3e QDIFFTOL:%1.3e QTOLCHK:%d\r", mpfr_get_d(Lold,GMP_RNDN),mpfr_get_d(Lnew,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN),TOL,LTOLCHK);
		
						} else if (FULLQ==2){
							
							if(mpfr_cmp (Sold,Snew) > 0) {mpfr_set(ptmp3,Snew,GMP_RNDN);}else{mpfr_set(ptmp3,Sold,GMP_RNDN);}
					
							mpfr_sub(ptmp1,Sold,Snew,GMP_RNDN);
							mpfr_div(ptmp2,ptmp1,ptmp3,GMP_RNDN);
							mpfr_abs(ptmp2,ptmp2,GMP_RNDN);
							mpfr_set_d(ptmp1,TOL,GMP_RNDN);
			
							if((mpfr_less_p(ptmp2,ptmp1)!=0)) {LTOLCHK++;}else{ LTOLCHK=0; }
			
							if((mpfr_less_p(Lnew,ptmp1)!=0)) {LTOLCHK=2;}
			
							fprintf(stderr, "Sold:%1.3e Snew:%1.3e |Sold-Snew|/Min(Snew,Sold):%1.3e QDIFFTOL:%1.3e QTOLCHK:%d\r", mpfr_get_d(Sold,GMP_RNDN),mpfr_get_d(Snew,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN),TOL,LTOLCHK);
		
						} else if (FULLQ==1){
							
							if(mpfr_cmp (Qold,Qnew) > 0) {mpfr_set(ptmp3,Qnew,GMP_RNDN);}else{mpfr_set(ptmp3,Qold,GMP_RNDN);}
					
							mpfr_sub(ptmp1,Qold,Qnew,GMP_RNDN);
							mpfr_div(ptmp2,ptmp1,ptmp3,GMP_RNDN);
							mpfr_abs(ptmp2,ptmp2,GMP_RNDN);
							mpfr_set_d(ptmp1,TOL,GMP_RNDN);
			
// 							fprintf(stderr, "COMPARE Qn-Qo/Qmax=%e TOL:%e CHECK LTOL:%d\n", mpfr_get_d(ptmp2,GMP_RNDN), TOL, mpfr_less_p(ptmp2,ptmp1) );
							
							if((mpfr_less_p(ptmp2,ptmp1)!=0)) {LTOLCHK++;}else{ LTOLCHK=0; }
			
							fprintf(stderr, "Qold:%1.3e Qnew:%1.3e |Qold-Qnew|/Min(Qnew,Qold):%1.3e QDIFFTOL:%1.3e QTOLCHK:%d\r", mpfr_get_d(Qold,GMP_RNDN),mpfr_get_d(Qnew,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN),TOL,LTOLCHK);
							
						}

						//*********************************************************
						//	CHECK THE DEVIATION FROM THE SINGULAR SUBSPACE
						//*********************************************************

						if(CHECKSINGSUB!=0) if(iter%CHECKSINGSUB==0){
								
								gslgmp_vector *atmp, *btmp;
								
								//*********************************************************
								//	NOW PROJECT DOWN TO THE SINGULAR SUBSPACE USING
								//	THE ORTHONORMALITY OF THE MATRIX Us
								//*********************************************************
								fprintf(stderr, "\n**********************************************************\n");
								fprintf(stderr, "***   PROJECT ONTO THE SINGULAR SUBSPACE, CHECK          ***\n");
								fprintf(stderr, "**********************************************************\n");
								
								for(int i=0;i<NSINGEXT;i++){
								mpfr_set(b->data[i],lbfgsstate.x(i).getReadPtr(),GMP_RNDN);						
								}
				
								//*********************************************************
								//	Calculate the current A vector
								//*********************************************************

								gmp_multmv(UsExt,0,b,a);

								btmp=gslgmp_vector_calloc(NSINGEXT);
								
								atmp=gslgmp_vector_calloc(NOMEGA);
								
								for(int COMP=0;COMP<NSINGEXT;COMP++){
									
									//*********************************************************
									//	WE NEED THE VECTOR PRODUCT BETWEEN THE COLUMNS OF
									//	US AND THE CURRENT a AS WELL AS THEIR NORM (=1)
									//*********************************************************
									
									mpfr_set_ui(ptmp1,0,GMP_RNDN);
									
									for(int w=0;w<NOMEGA;w++){
									
										mpfr_mul(ptmp4,a->data[w],UsExt->data[w*NSINGEXT+COMP],GMP_RNDN);
										mpfr_add(ptmp1,ptmp1,ptmp4,GMP_RNDN);

									}
									
									mpfr_set(btmp->data[COMP],ptmp1,GMP_RNDN);
									
									fprintf(stderr, "SUBSPACE b[%d]:%e\n", COMP, mpfr_get_d(btmp->data[COMP],GMP_RNDN));
									
								}
								
								gmp_multmv(UsExt,0,btmp,atmp);
								
								mpfr_set_ui(ptmp4,0,GMP_RNDN);
								
								for(int i=0;i<NOMEGA;i++){
									
									mpfr_sub(ptmp1,atmp->data[i],a->data[i],GMP_RNDN);
									mpfr_pow_ui(ptmp1,ptmp1,2,GMP_RNDN);
									mpfr_mul_d(ptmp1,ptmp1,0.5,GMP_RNDN);
								
									mpfr_add(ptmp4,ptmp4,ptmp1,GMP_RNDN);
								}
								
								mpfr_sqrt(ptmp4,ptmp4,GMP_RNDN);
								mpfr_div_ui(ptmp4,ptmp4,NOMEGA,GMP_RNDN);
								
								fprintf(stderr, "Difference in a after projection: %e\n", mpfr_get_d(ptmp4,GMP_RNDN));
									
								gslgmp_vector_free(atmp);	
								gslgmp_vector_free(btmp);	
								
								fprintf(PROJVAL, "%d %d %d %e\n", DX, acnt, iter,mpfr_get_d(ptmp4,GMP_RNDN));
								fflush(PROJVAL);
								
							}
						
						fprintf(ITERVAL, "%d %d %d %e %e %e\n", DX, acnt, iter, mpfr_get_d(Lval,GMP_RNDN),mpfr_get_d(Sval,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN));
						fflush(ITERVAL);


						iter++;
		
					}
					
					
					for(int dw=0;dw<NSINGEXT;dw++){
						mpfr_set(blbfgsSVD->data[dw],lbfgsstate.x(dw).getReadPtr(),GMP_RNDN);
					}
					
					}
					
					LTOLCHK=0;
			
					//*************************************************************************
					//	INITIALIZATION OF THE LM MINIMIZER AND ITS TOLERANCE
					//*************************************************************************
					//iter =0;
					
					minlm::minlmstate lmstate;
					minlm::minlmreport lmrep;
					ap::template_1d_array< amp::ampf > lmb;
					lmb.setlength(NSINGEXT);

					for(int i=0;i<NSINGEXT;i++){
				
						mpfr_set(lmb(i).getWritePtr(),blbfgsSVD->data[i],GMP_RNDN);
						
					}
					
 					
					minlm::minlmcreatefgh(NSINGEXT, lmb, lmstate);
					
					minlm::minlmsetcond(lmstate, epsg, epsf, epsx, maxits);

					//*************************************************************************
					//	THE ITERATION LOOP                                
					//*************************************************************************

					fprintf(stderr, "\n**********************************************************\n");
					fprintf(stderr, "**** STARTING WITH THE LM MINIMIZER               ********\n");
					fprintf(stderr, "**********************************************************\n");

					while( minlm::minlmiteration(lmstate) && LTOLCHK < 3 && iter < maxits )
					{
				
						mpfr_set(Lold,Lnew,GMP_RNDN);
						mpfr_set(Sold,Snew,GMP_RNDN);
						mpfr_set(Qold,Qnew,GMP_RNDN);
						
						for(int i=0;i<NSINGEXT;i++){
						mpfr_set(b->data[i],lmstate.x(i).getReadPtr(),GMP_RNDN);						
						}
			
						//*********************************************************
						//	Calculate the current A vector
						//*********************************************************

						gmp_multmv(UsExt,0,b,a);

						for(int dw=0;dw<NOMEGA;dw++){
						mpfr_exp(A->data[dw],a->data[dw],GMP_RNDN);						
						mpfr_mul(A->data[dw],A->data[dw],mprior->data[dw],GMP_RNDN);
						}
						
						//*********************************************************
						//	ADD THE NECESSARY DW FACTORS FOR THE INTEGRAL
						//*********************************************************
						
						append_dw(Adw,A,omega,NOMEGA,HPNUM,OMEGAHPMIN,OMEGAHPMAX);

						//*********************************************************
						//	Generate data from the current A
						//*********************************************************
					
						gmp_multmv(DCKernel,0,Adw,DA);
					
						//*********************************************************
						//	Calculate L value (3.40)
						//*********************************************************
				
						mpfr_set_ui(Lval,0,GMP_RNDN);
	
						//*********************************************************
						//	IF DATA IS DECORRELATED, ONLY NEED TO USE ONE FOR
						//	LOOP. IF NOT, SLOW DOUBLE LOOP NECCESARY
						//*********************************************************
	
						#if (DECORR==1)
							for(int i=0;i<TWIDTH;i++){
						
								mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
								mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
							
								mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
								mpfr_pow_ui(ptmp1,ptmp3,2,GMP_RNDN);
								
								mpfr_div(ptmp2,ptmp1,CEval->data[i],GMP_RNDN);
								mpfr_div_ui(ptmp3,ptmp2,2,GMP_RNDN);
								
								mpfr_set(ptmp1,Lval,GMP_RNDN);
								mpfr_add(Lval,ptmp1,ptmp3,GMP_RNDN);
								}
						#else
							for(int i=0;i<TWIDTH;i++){
							for(int j=0;j<TWIDTH;j++){
						
								mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
								mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
							
								mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
				
								mpfr_set(ptmp1,DCDXData->data[j],GMP_RNDN);
								mpfr_set(ptmp2,DA->data[j],GMP_RNDN);
				
								mpfr_sub(ptmp4,ptmp1,ptmp2,GMP_RNDN);
				
								mpfr_mul(ptmp1,ptmp3,ptmp4,GMP_RNDN);
				
								gslgmp_matrix_get(CInv,i,j,ptmp2);
				
								mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);
				
								mpfr_div_ui(ptmp2,ptmp3,2,GMP_RNDN);
							
								mpfr_set(ptmp1,Lval,GMP_RNDN);
								mpfr_add(Lval,ptmp1,ptmp2,GMP_RNDN);
								}}
						#endif	
		
						//*********************************************************
						//	FROM NICKEL: THERE NEEDS TO BE A DT TERM
						//	HOWEVER JUST COMES IN AS ALPHA RESCALING
						//*********************************************************

						//*********************************************************
						//	Calculate S value (3.13)
						//*********************************************************
					
						mpfr_set_d(Sval,0.,GMP_RNDN);
		
						for(int dw=0;dw<NOMEGA;dw++){

							mpfr_div(ptmp1, A->data[dw],mprior->data[dw],GMP_RNDN);
							mpfr_log(ptmp2,ptmp1,GMP_RNDN);
							mpfr_mul(ptmp3,ptmp2,Adw->data[dw],GMP_RNDN);
							
							mpfr_sub(ptmp1,Adw->data[dw],mpriordw->data[dw],GMP_RNDN);
							mpfr_sub(ptmp2,ptmp1,ptmp3,GMP_RNDN);

							mpfr_set(ptmp1,Sval,GMP_RNDN);
							mpfr_add(Sval,ptmp1,ptmp2,GMP_RNDN);
		
						}
		
						//*********************************************************
						//	IF FULLQ==1 THEN Q IS MINIMIZED
						//	IF FULLQ==0 THEN only L IS MINIMIZED
						//*********************************************************
						if (FULLQ==0){
							mpfr_set(lmstate.f.getWritePtr(),Lval,GMP_RNDN);
						}else if (FULLQ==2){
							mpfr_neg(lmstate.f.getWritePtr(),Sval,GMP_RNDN);
						}else if (FULLQ==1){
							mpfr_set_d(ptmp1,alpha,GMP_RNDN);
							mpfr_mul(ptmp2,ptmp1,Sval,GMP_RNDN);
							mpfr_sub(lmstate.f.getWritePtr(),Lval,ptmp2,GMP_RNDN);
							mpfr_set(Qnew,lmstate.f.getReadPtr(),GMP_RNDN);
						}
		
						//*********************************************************
						//	CALCULATE THE TRUE -Q DERIVATIVE             
						//*********************************************************
						
						if(lmstate.needfg || lmstate.needfgh){

							mpfr_set(Lnew,Lval,GMP_RNDN);
							mpfr_set(Snew,Sval,GMP_RNDN);
						
							for(int comp=0;comp<NSINGEXT;comp++){
								
								//*********************************************************
								//	Calculate the derivative of L w.r.t. a_k
								//*********************************************************
			
								mpfr_set_ui(Lderiv,0,GMP_RNDN);
							
								#if (DECORR==1)
								
								for(int i=0;i<TWIDTH;i++){
						
									mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
									mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
									mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);

									mpfr_set_ui(ptmp4,0,GMP_RNDN);
									
									for(int l=0; l<NOMEGA;l++){
									
									#if (WITHDW==0)
										mpfr_mul(ptmp1,DCKernel->data[i*(NOMEGA)+l],A->data[l],GMP_RNDN);
									#else
										mpfr_mul(ptmp1,DCKernel->data[i*(NOMEGA)+l],Adw->data[l],GMP_RNDN);
									#endif
									
										mpfr_mul(ptmp1,ptmp1,UsExt->data[l*(NSINGEXT)+comp],GMP_RNDN);
										mpfr_add(ptmp4,ptmp4,ptmp1,GMP_RNDN);
									
									}
									
									mpfr_mul(ptmp1,ptmp3,ptmp4,GMP_RNDN);
									mpfr_div(ptmp2,ptmp1,CEval->data[i],GMP_RNDN);
					
									mpfr_sub(Lderiv,Lderiv,ptmp2,GMP_RNDN);
									}
									
								#else

									fprintf(stderr, "NOT IMPLEMENTED YET\n"); exit(-1);

								#endif
								//*********************************************************
								//	FROM NICKEL: THERE NEEDS TO BE A DT TERM
								//	HOWEVER JUST COMES IN AS ALPHA RESCALING
								//*********************************************************

								//*********************************************************
								//	Calculate the derivative of S
								//*********************************************************
			
								mpfr_set_ui(Sderiv,0,GMP_RNDN);

								
								for(int l=0; l<NOMEGA;l++){
								
									mpfr_div(ptmp1,A->data[comp],mprior->data[comp],GMP_RNDN);
									mpfr_log(ptmp2,ptmp1,GMP_RNDN);

									#if (WITHDW==0)
									mpfr_mul(ptmp1,UsExt->data[l*(NSINGEXT)+comp],A->data[comp],GMP_RNDN); //DELTA FUNCTION INTRODUCES 1/dw
									#else
									mpfr_mul(ptmp1,UsExt->data[l*(NSINGEXT)+comp],Adw->data[comp],GMP_RNDN);//FROM COMPARISON OF THE NUMERICAL DERIVATIVE
									#endif
									
									mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);
									
									mpfr_sub(Sderiv,Sderiv,ptmp3,GMP_RNDN);
								
								}
								
								if (FULLQ==0){
									mpfr_set(lmstate.g(comp).getWritePtr(),Lderiv,GMP_RNDN);
								} else if (FULLQ==2){
									mpfr_neg(lmstate.g(comp).getWritePtr(),Sderiv,GMP_RNDN);
								} else if (FULLQ==1){
									mpfr_set_d(ptmp1,alpha,GMP_RNDN);
									mpfr_mul(ptmp2,ptmp1,Sderiv,GMP_RNDN);
									mpfr_sub(lmstate.g(comp).getWritePtr(),Lderiv,ptmp2,GMP_RNDN);
								}
								
							}
							
							//*********************************************************
							//	CALCULATE THE -Q HESSIAN        
							//*********************************************************
							
							if( lmstate.needfgh ){
								
								gslgmp_matrix* AM;
								AM=gslgmp_matrix_calloc(TWIDTH,NSINGEXT);
								
								for(int t=0;t<TWIDTH;t++){
								for(int c2=0;c2<NSINGEXT;c2++){
									
									mpfr_set_ui(ptmp4,0,GMP_RNDN);
									for(int l=0;l<NOMEGA;l++){
										
										mpfr_mul(ptmp1,DCKernel->data[t*NOMEGA+l],Adw->data[l],GMP_RNDN);
										mpfr_mul(ptmp1,ptmp1,UsExt->data[l*NSINGEXT+c2],GMP_RNDN);
										mpfr_add(ptmp4,ptmp4,ptmp1,GMP_RNDN);
										
									}
									mpfr_set(AM->data[t*NSINGEXT+c2],ptmp4,GMP_RNDN);
								}}

	//fprintf(stderr,"DEBUG SVD 4.1\n");

								for(int c1=0;c1<NSINGEXT;c1++){
								for(int c2=0;c2<=c1;c2++){
	//fprintf(stderr,"DEBUG SVD 4.2\n");
						
									mpfr_set_ui(ptmp4,0,GMP_RNDN);
									
									for(int i=0;i<TWIDTH;i++){
										
										mpfr_mul(ptmp1,AM->data[i*NSINGEXT+c1],AM->data[i*NSINGEXT+c2],GMP_RNDN);
										mpfr_div(ptmp1,ptmp1,CEval->data[i],GMP_RNDN);
										mpfr_add(ptmp4,ptmp4,ptmp1,GMP_RNDN);

										
										mpfr_set(ptmp1,DCDXData->data[i],GMP_RNDN);
										mpfr_set(ptmp2,DA->data[i],GMP_RNDN);
										mpfr_sub(ptmp3,ptmp1,ptmp2,GMP_RNDN);
										mpfr_div(ptmp2,ptmp3,CEval->data[i],GMP_RNDN);
											
										mpfr_set_ui(ptmp5,0,GMP_RNDN);

										for(int l=0;l<NOMEGA;l++){
											
											mpfr_mul(ptmp1,DCKernel->data[i*NOMEGA+l],Adw->data[l],GMP_RNDN);
											mpfr_mul(ptmp1,ptmp1,UsExt->data[l*NSINGEXT+c2],GMP_RNDN);
											mpfr_mul(ptmp1,ptmp1,UsExt->data[l*NSINGEXT+c1],GMP_RNDN);
											mpfr_add(ptmp5,ptmp5,ptmp1,GMP_RNDN);
											
										}
										
										mpfr_mul(ptmp5,ptmp5,ptmp2,GMP_RNDN);
										mpfr_sub(ptmp4,ptmp4,ptmp5,GMP_RNDN);
									
									}


									mpfr_set_ui(ptmp5,0,GMP_RNDN);

	//fprintf(stderr,"DEBUG SVD 4.3\n");
									for(int l=0; l<NOMEGA;l++){
									
										mpfr_div(ptmp1,A->data[l],mprior->data[l],GMP_RNDN);
										mpfr_log(ptmp2,ptmp1,GMP_RNDN);
										mpfr_add_ui(ptmp2,ptmp2,1,GMP_RNDN);
										
										mpfr_mul(ptmp1,UsExt->data[l*NSINGEXT+c1],UsExt->data[l*NSINGEXT+c2],GMP_RNDN);
										mpfr_mul(ptmp1,ptmp1,Adw->data[l],GMP_RNDN);
									
										mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);
										
										mpfr_sub(ptmp5,ptmp5,ptmp3,GMP_RNDN);
									
									}
	//fprintf(stderr,"DEBUG SVD 4.4\n");

									if (FULLQ==0){
										mpfr_set(lmstate.h(c1,c2).getWritePtr(),ptmp4,GMP_RNDN);
										mpfr_set(lmstate.h(c2,c1).getWritePtr(),ptmp4,GMP_RNDN);
									}else if (FULLQ==2){
										mpfr_neg(lmstate.h(c1,c2).getWritePtr(),ptmp5,GMP_RNDN);
										mpfr_neg(lmstate.h(c2,c1).getWritePtr(),ptmp5,GMP_RNDN);
									} else if (FULLQ==1) {
										mpfr_set_d(ptmp1,alpha,GMP_RNDN);
										mpfr_mul(ptmp2,ptmp1,ptmp5,GMP_RNDN);
										mpfr_sub(lmstate.h(c1,c2).getWritePtr(),ptmp4,ptmp2,GMP_RNDN);
										mpfr_sub(lmstate.h(c2,c1).getWritePtr(),ptmp4,ptmp2,GMP_RNDN);
									}
									
								}}
							
	//fprintf(stderr,"DEBUG SVD 4.5\n");
								gslgmp_matrix_free(AM);
								
							}
						
						}
		
						//*********************************************************
						//	Measure |dL|
						//*********************************************************
						
						double dQ=0;
						for(int i=0; i<NSINGEXT;i++) dQ+=mpfr_get_d(lmstate.g(i).getReadPtr(),GMP_RNDN);
						
			
						//*********************************************************
						//	Print status report for the current iteration
						//*********************************************************

						if (FULLQ==0){
							fprintf(stderr, "N%3d Iter %3d with ALPHA:%e L:% 1.3e dL:%1.3e ", MYRANK, iter,alpha,mpfr_get_d(Lval,GMP_RNDN), dQ);
						} else if (FULLQ==2){
							fprintf(stderr, "N%3d Iter %3d with ALPHA:%e L:% 1.3e dL:%1.3e ", MYRANK, iter,alpha,mpfr_get_d(Lval,GMP_RNDN), dQ);							
						} else if (FULLQ==1){
							fprintf(stderr, "N%3d Iter %3d with ALPHA:%e Q:% 1.3e dQ:%1.3e L:% 1.3e S:% 1.3e ", MYRANK, iter,alpha,mpfr_get_d(lmstate.f.getReadPtr(),GMP_RNDN),dQ,mpfr_get_d(Lval,GMP_RNDN),mpfr_get_d(Sval,GMP_RNDN) );
						}


						//*********************************************************
						//	Additional Convergence check
						//*********************************************************
		
						if (FULLQ==0) {
							if(mpfr_cmp (Lold,Lnew) > 0) {mpfr_set(ptmp3,Lnew,GMP_RNDN);}else{mpfr_set(ptmp3,Lold,GMP_RNDN);}
					
							mpfr_sub(ptmp1,Lold,Lnew,GMP_RNDN);
							mpfr_div(ptmp2,ptmp1,ptmp3,GMP_RNDN);
							mpfr_abs(ptmp2,ptmp2,GMP_RNDN);
							mpfr_set_d(ptmp1,TOL,GMP_RNDN);
			
							if((mpfr_less_p(ptmp2,ptmp1)!=0)) {LTOLCHK++;}else{ LTOLCHK=0; }
			
							if((mpfr_less_p(Lnew,ptmp1)!=0)) {LTOLCHK=2;}
			
							fprintf(stderr, "Lold:%1.3e Lnew:%1.3e |Lold-Lnew|/Min(Lnew,Lold):%1.3e QDIFFTOL:%1.3e QTOLCHK:%d\r", mpfr_get_d(Lold,GMP_RNDN),mpfr_get_d(Lnew,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN),TOL,LTOLCHK);
		
						} else if (FULLQ==2){
							
							if(mpfr_cmp (Sold,Snew) > 0) {mpfr_set(ptmp3,Snew,GMP_RNDN);}else{mpfr_set(ptmp3,Sold,GMP_RNDN);}
					
							mpfr_sub(ptmp1,Sold,Snew,GMP_RNDN);
							mpfr_div(ptmp2,ptmp1,ptmp3,GMP_RNDN);
							mpfr_abs(ptmp2,ptmp2,GMP_RNDN);
							mpfr_set_d(ptmp1,TOL,GMP_RNDN);
			
							if((mpfr_less_p(ptmp2,ptmp1)!=0)) {LTOLCHK++;}else{ LTOLCHK=0; }
			
							if((mpfr_less_p(Lnew,ptmp1)!=0)) {LTOLCHK=2;}
			
							fprintf(stderr, "Sold:%1.3e Snew:%1.3e |Sold-Snew|/Min(Snew,Sold):%1.3e QDIFFTOL:%1.3e QTOLCHK:%d\r", mpfr_get_d(Sold,GMP_RNDN),mpfr_get_d(Snew,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN),TOL,LTOLCHK);
		
						} else if (FULLQ==1){
							
							if(mpfr_cmp (Qold,Qnew) > 0) {mpfr_set(ptmp3,Qnew,GMP_RNDN);}else{mpfr_set(ptmp3,Qold,GMP_RNDN);}
					
							mpfr_sub(ptmp1,Qold,Qnew,GMP_RNDN);
							mpfr_div(ptmp2,ptmp1,ptmp3,GMP_RNDN);
							mpfr_abs(ptmp2,ptmp2,GMP_RNDN);
							mpfr_set_d(ptmp1,TOL,GMP_RNDN);
			
							if((mpfr_less_p(ptmp2,ptmp1)!=0) ) {LTOLCHK++;}else{ LTOLCHK=0; }
			
							fprintf(stderr, "Qold:%1.3e Qnew:%1.3e |Qold-Qnew|/Min(Qnew,Qold):%1.3e QDIFFTOL:%1.3e QTOLCHK:%d\r", mpfr_get_d(Qold,GMP_RNDN),mpfr_get_d(Qnew,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN),TOL,LTOLCHK);
						
						}
			
						//*********************************************************
						//	CHECK DEVIATION FROM SINGULAR SUBSPACE
						//*********************************************************
						
							if(iter%CHECKSINGSUB==0){
								
								gslgmp_vector *atmp, *btmp;
								
								//*********************************************************
								//	NOW PROJECT DOWN TO THE SINGULAR SUBSPACE USING
								//	THE ORTHONORMALITY OF THE MATRIX Us
								//*********************************************************
								fprintf(stderr, "\n**********************************************************\n");
								fprintf(stderr, "***   PROJECT ONTO THE SINGULAR SUBSPACE, CHECK          ***\n");
								fprintf(stderr, "**********************************************************\n");
								
								for(int i=0;i<NSINGEXT;i++){
								mpfr_set(b->data[i],lmstate.x(i).getReadPtr(),GMP_RNDN);						
								}
				
								//*********************************************************
								//	Calculate the current A vector
								//*********************************************************

								gmp_multmv(UsExt,0,b,a);

								btmp=gslgmp_vector_calloc(NSINGEXT);
								
								atmp=gslgmp_vector_calloc(NOMEGA);
								
								for(int COMP=0;COMP<NSINGEXT;COMP++){
									
									//*********************************************************
									//	WE NEED THE VECTOR PRODUCT BETWEEN THE COLUMNS OF
									//	US AND THE CURRENT a AS WELL AS THEIR NORM (=1)
									//*********************************************************
									
									mpfr_set_ui(ptmp1,0,GMP_RNDN);
									
									for(int w=0;w<NOMEGA;w++){
									
										mpfr_mul(ptmp4,a->data[w],UsExt->data[w*NSINGEXT+COMP],GMP_RNDN);
										mpfr_add(ptmp1,ptmp1,ptmp4,GMP_RNDN);

									}
									
									mpfr_set(btmp->data[COMP],ptmp1,GMP_RNDN);
									
									fprintf(stderr, "SUBSPACE b[%d]:%e\n", COMP, mpfr_get_d(btmp->data[COMP],GMP_RNDN));
									
								}
								
								gmp_multmv(UsExt,0,btmp,atmp);
								
								mpfr_set_ui(ptmp4,0,GMP_RNDN);
								
								for(int i=0;i<NOMEGA;i++){
									
									mpfr_sub(ptmp1,atmp->data[i],a->data[i],GMP_RNDN);
									mpfr_pow_ui(ptmp1,ptmp1,2,GMP_RNDN);
									mpfr_mul_d(ptmp1,ptmp1,0.5,GMP_RNDN);
								
									mpfr_add(ptmp4,ptmp4,ptmp1,GMP_RNDN);
								}
								
								mpfr_sqrt(ptmp4,ptmp4,GMP_RNDN);
								mpfr_div_ui(ptmp4,ptmp4,NOMEGA,GMP_RNDN);
								
								fprintf(stderr, "Difference in a after projection: %e\n", mpfr_get_d(ptmp4,GMP_RNDN));
									
								gslgmp_vector_free(atmp);	
								gslgmp_vector_free(btmp);	
								
								fprintf(PROJVAL, "%d %d %d %e\n", DX, acnt, iter,mpfr_get_d(ptmp4,GMP_RNDN));
								fflush(PROJVAL);
								
							}
							
							
						fprintf(ITERVAL, "%d %d %d %e %e %e\n", DX, acnt, iter, mpfr_get_d(Lval,GMP_RNDN),mpfr_get_d(Sval,GMP_RNDN),mpfr_get_d(ptmp2,GMP_RNDN));
						fflush(ITERVAL);

						iter++;		
					}
		
					if(LTOLCHK!=3){
						minlm::minlmresults(lmstate, lmb, lmrep);					
						fprintf(stderr,"\n\nLM INTERNAL TERMINATION TYPE:%d\n",lmrep.terminationtype);
						
						for(int dw=0;dw<NSINGEXT;dw++){
						mpfr_set(blbfgsSVD->data[dw],lmb(dw).getReadPtr(),GMP_RNDN);
						}
		
					}else{
						fprintf(stderr,"\n\nLM FINISHED BECAUSE (qold-qnew)/qnew < TOL\n");
			
						for(int dw=0;dw<NSINGEXT;dw++){
						mpfr_set(blbfgsSVD->data[dw],lmstate.x(dw).getReadPtr(),GMP_RNDN);
						}
					}
